package cn.iocoder.yudao.module.system.controller.admin.home;

import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.tenant.core.aop.TenantIgnore;
import cn.iocoder.yudao.framework.tenant.core.context.TenantContextHolder;
import cn.iocoder.yudao.module.system.controller.admin.home.vo.HomeServicePackagePageReqVO;
import cn.iocoder.yudao.module.system.controller.admin.home.vo.HomeServicePackageRespVO;
import cn.iocoder.yudao.module.system.controller.admin.home.vo.HomeServicePackageSaveReqVO;
import cn.iocoder.yudao.module.system.service.home.HomeServicePackageService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.validation.Valid;

import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;

@Tag(name = "管理后台 - 居家服务套餐")
@RestController
@RequestMapping("/home/service-package")
@Validated
public class HomeServicePackageController {

    @Resource
    private HomeServicePackageService homeServicePackageService;

    @PostMapping("/create")
    @Operation(summary = "新增居家服务套餐")
    @TenantIgnore
    public CommonResult<Long> create(@Valid @RequestBody HomeServicePackageSaveReqVO createReqVO) {
        if (createReqVO.getTenantId() == null) {
            createReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        return success(homeServicePackageService.createHomeServicePackage(createReqVO));
    }

    @PutMapping("/update")
    @Operation(summary = "修改居家服务套餐")
    @TenantIgnore
    public CommonResult<Boolean> update(@Valid @RequestBody HomeServicePackageSaveReqVO updateReqVO) {
        if (updateReqVO.getTenantId() == null) {
            updateReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        homeServicePackageService.updateHomeServicePackage(updateReqVO);
        return success(true);
    }

    @DeleteMapping("/delete")
    @Operation(summary = "删除居家服务套餐")
    @Parameter(name = "id", description = "编号", required = true, example = "1")
    @TenantIgnore
    public CommonResult<Boolean> delete(@RequestParam("id") Long id) {
        homeServicePackageService.deleteHomeServicePackage(id);
        return success(true);
    }

    @GetMapping("/get")
    @Operation(summary = "获得居家服务套餐详情")
    @Parameter(name = "id", description = "编号", required = true, example = "1")
    @TenantIgnore
    public CommonResult<HomeServicePackageRespVO> get(@RequestParam("id") Long id) {
        return success(homeServicePackageService.getHomeServicePackage(id));
    }

    @GetMapping("/page")
    @Operation(summary = "获得居家服务套餐分页")
    @TenantIgnore
    public CommonResult<PageResult<HomeServicePackageRespVO>> page(@Valid HomeServicePackagePageReqVO pageReqVO) {
        if (pageReqVO.getTenantId() == null) {
            pageReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        return success(homeServicePackageService.getHomeServicePackagePage(pageReqVO));
    }
}
